//Copyright (c) 2003, Alexander Oganezov
//ALL RIGHTS RESERVED

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif


#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "draw.h"
#include "defines.h"
#include "vroom.h"
#include "levels.h"
#include "generate.h"
#include <dirent.h>
#include "statusbar.h"
#include "areaio.h"


char areaname[200];
GtkWidget *fileselection, *statusbar, *dl3,*preview_dialog,*root,*canvas;
GtkWidget *notebook, *fileselection3,*fileselection2;
GnomeCanvasGroup *group;
extern _vroom;
extern _vexitnode;
extern _level;
GtkWidget *gen_dialog;
struct _vroom *myroom;
struct _vroom *_curroom;
struct _vroom* head;
int whattodo,cntr,curx, cury,isrx, isry;
//int _level;
struct _level *head_level;
struct _level *cur_level;

	GtkWidget *wgpl;
//initalizes things here
	void set_root(GtkWidget *w) {
		double mx_scroll;
		
		GtkSettings *settings;
		char *home;
		char mb_dir[100];
		char filez[100];
		char conf_file[100];
		char cppp[300];
		DIR *tmpdr;
		
		
		whattodo=0;
		memset(areaname,0x0,200);
		tmpdr=0;
		home=getenv("HOME");
		
		strcpy(mb_dir,home);
		strcat(mb_dir,"/.mudsbuilder");

		tmpdr=opendir(mb_dir);
		
		if (tmpdr==0) 
		{
			g_print("Creating %s\n",mb_dir);
			mkdir(mb_dir,0777);

			g_print("Creating config files\n");
			strcpy(cppp,"cp ");
			strcat(cppp,PACKAGE_DATA_DIR);
			strcat(cppp,"/etc/* ");
			strcat(cppp,mb_dir);
			strcat(cppp,"/");
			system(cppp);
		
			strcpy(conf_file,PACKAGE_DATA_DIR);
			strcat(conf_file,"/etc/gereacreator.conf");
			
		}
		else {
		closedir(tmpdr);
		
			strcpy(conf_file,mb_dir);
			strcat(conf_file,"/gereacreator.conf");
		}

		load_options(conf_file);
		settings=gtk_settings_get_default();
		g_object_set(G_OBJECT(settings),"gtk-font-name",APP_FONT,NULL);
		
		mx_scroll=GSIZE*RSIZE2;
		root=w;
		canvas=lookup_widget(root,"canvas1");
		notebook=lookup_widget(root,"notebook1");
		
		gnome_canvas_set_scroll_region((GnomeCanvas*)canvas,0.0,0.0,mx_scroll,
		mx_scroll);
		group=gnome_canvas_root((GnomeCanvas*)canvas);
		cntr=1; curx=-1; cury=-1;
		draw_grid(group,GRID_COLOR);
		
		head_level=new__level();
		head_level->canvas=canvas;
		head_level->group=group;
		
		head_level->lev_id=0;
		cur_level=head_level;
		cur_level->_zoom=1.0;
		
		statusbar=lookup_widget(root,"statusbar1");
		status_msg("Click anywhere on grid to start!");
		free(home);
	}


	void
	on_window1_destroy                     (GtkObject       *object,
						gpointer         user_data)
	{
		gtk_main_quit();
	}



	//when key is pressed
	gboolean
	on_canvas1_key_press_event             (GtkWidget       *widget,
						GdkEventKey     *event,
						gpointer         user_data)
	{
		double daexits[8];
		char buf[300];
		double xm[]=
		{-RSIZE3,0,RSIZE3,-RSIZE3,0,RSIZE3,-RSIZE3,0,RSIZE3};
		double ym[]=
		{RSIZE3,RSIZE3,RSIZE3,0,0,0,-RSIZE3,-RSIZE3,-RSIZE3};

		struct _vroom *oldroom;
		int i;
		int ek;
		int scx,scy;
		double xx1,yy1,xx2,yy2;
		struct _vroom *tmpvroom;
		double tmpdae;
		struct _vexitnode *tmpvnode, *oldvnode;

		if (curx==-1 || cury==-1) {
		status_msg("You must select starting location first!");
		return FALSE;
		}
		
		
		for (i=0; i<8; i++) daexits[i]=0;
		ek=event->keyval-65456;
		
		
		//no key on pad or delete pressed
		if ((ek>9 || ek<1 || ek==5) && ek!=79)
		{
			status_msg("Unrecognized key pressed");
			return TRUE;	
		}
		
		if (head && _curroom->rlevel!=cur_level)
		switch_to_current_level();
		
		if (ek!=79) {
			curx+=xm[ek-1];
			cury+=ym[ek-1];
		
			if (curx<0 || cury<0) {
				curx-=xm[ek-1];
				cury-=ym[ek-1];
				return TRUE;
			}

			sprintf(buf,"%i",cntr);
			if (ek<5) daexits[7-(ek-1)]=1;
			if (ek>5) daexits[7-(ek-2)]=1;

			//if room exists at that location - just switch to it
			tmpvroom=head;
			while (tmpvroom!=0)
			{
				
				if (tmpvroom->x==curx && tmpvroom->y==cury && 
					tmpvroom->rlevel==cur_level)
				{
					set_exits(tmpvroom,daexits);
					for (i=0; i<4; i++)
					{	
					tmpdae=daexits[i];
					daexits[i]=daexits[7-i];
					daexits[7-i]=tmpdae;
					}
					set_exits(_curroom,daexits);
					//linking roomz
					link_rooms(tmpvroom,_curroom,daexits);
					set_curroom(tmpvroom);
					return KPRET;
				}
				tmpvroom=tmpvroom->next;
			}


			//creating new room
			myroom=(struct _vroom*)new_vroom();
			new_room(myroom,buf,curx,cury);
			//setting up exits of new room created
			set_exits(myroom,daexits);
			//setting up exits of current room
			for (i=0; i<4; i++)
			{	
				tmpdae=daexits[i];
				daexits[i]=daexits[7-i];
				daexits[7-i]=tmpdae;
			}

			set_exits(_curroom,daexits);
			
			//linking roomz
			link_rooms(myroom,_curroom,daexits);

			//relinking list of rooms
			myroom->next=head;
			head->prev=myroom;
			head=myroom;
			
			set_curroom(myroom);
			cntr++;

		} else  {
			//deleting room;
			if (_curroom!=head) 
			{
				if (_curroom->prev!=0)
				_curroom->prev->next=_curroom->next;
				
				if (_curroom->next!=0)
				_curroom->next->prev=_curroom->prev;
			} else {
				head=_curroom->next;
			}

			gtk_object_destroy((GtkObject*)_curroom->rectangle);
			gtk_object_destroy((GtkObject*)_curroom->text);
			
			if (head!=0) {
			for (i=0; i<8; i++) {
				if (_curroom->rexit[i]) 
				{
					gtk_object_destroy((GtkObject*)_curroom->rexit[i]);
					if (_curroom->room_ptr[i] && _curroom->room_ptr[i]->rexit[7-i]!=0) {
						gtk_object_destroy((GtkObject*) _curroom->room_ptr[i]->rexit[7-i]);	
				
						_curroom->room_ptr[i]->room_ptr[7-i]=0;
						_curroom->room_ptr[i]->rexit[7-i]=0;
					}
				}
				gnome_canvas_points_free(_curroom->points[i]);
			}
			
			if (_curroom->down) {
				gtk_object_destroy((GtkObject*)_curroom->vdown);
				gtk_object_destroy((GtkObject*)_curroom->down->vup);
				_curroom->down->up=0;
				_curroom->down->vup=0;
				_curroom->down=0;
			}
			
			if (_curroom->vdown) {
			
			}
			
			if (_curroom->up) {
				gtk_object_destroy((GtkObject*)_curroom->vup);
				gtk_object_destroy((GtkObject*)_curroom->up->vdown);
				_curroom->up->vdown=0;
				_curroom->up->down=0;
				_curroom->down=0;
			}
			
			if (_curroom->vup) {
			
			}

			tmpvnode=_curroom->head_exit;
			//deleting misc exits
			while (tmpvnode!=0)
			{
				free(tmpvnode->ex_name);
				oldvnode=tmpvnode;
				tmpvnode=tmpvnode->next;
				gtk_object_destroy((GtkObject*)oldvnode->line);
				free(oldvnode);
			}
			
			level_destroy(_curroom->rlevel);
			free(_curroom);
			_curroom=0;
			_curroom=head;	
			curx=_curroom->x;
			cury=_curroom->y;
			set_curroom(head);
		
			if (head) switch_to_current_level();
			}
			else { curx=-1; cury=-1; cntr=1; level_destroy(cur_level); 
			tmpvnode=_curroom->head_exit;
			//deleting misc exits
			while (tmpvnode!=0)
			{
				free(tmpvnode->ex_name);
				oldvnode=tmpvnode;
				tmpvnode=tmpvnode->next;
				gtk_object_destroy((GtkObject*)oldvnode->line);
				free(oldvnode);
			}
			}
		}
	  return KPRET;
	}


	gboolean
	on_canvas1_button_press_event          (GtkWidget       *widget,
						GdkEventButton  *event,
						gpointer         user_data)
	{
		struct _vroom *tmpvroom;
		int cx,cy;
		char buf[300];
		int isroom;
		int gridx,gridy;
		int rz;
		int savedx,savedy;
		int i,checkx,checky;
		

		if (event->button!=1) return FALSE;

		status_msg("You can use numeric keypad now.");
		cx=(int)(event->x / cur_level->_zoom);
		cy=(int)(event->y / cur_level->_zoom);
		if (curx==-1 || cury==-1) 
		{
			curx=cx; 
			cury=cy;
			
			rz=RSIZE2;
			
			gridx=(int)((curx-RSIZE1) /rz);
			gridy=(int)((cury-RSIZE1) /rz);



			myroom=(struct _vroom*)new_vroom();
			sprintf(buf,"%i",cntr);
			curx=gridx*RSIZE2+RSIZE1;
			cury=gridy*RSIZE2+RSIZE1;
			new_room(myroom,buf,curx,cury);

			//check is done cause of load_area() in areaio.c
			if (head==0) {
			myroom->next=0;
			myroom->prev=0;	
			head=myroom;
			} else {
			myroom->next=head;
			head->prev=myroom;
			head=myroom;
			}

			cntr++;
			isrx=gridx % 2;
			isry=gridy % 2;	

			_curroom=myroom;
			set_curroom(myroom);
		} else {

		
		savedx=curx;
		savedy=cury;
		curx=cx;
		cury=cy;

		rz=RSIZE2;
		gridx=(int)((curx-RSIZE1) /rz);
		gridy=(int)((cury-RSIZE1) /rz);

		if (gridx % 2 !=isrx || gridy % 2 !=isry) {
			curx=savedx; cury=savedy;
			status_msg("This cell is reserved for exit");
			return FALSE;
		}
			curx=gridx*RSIZE2+RSIZE1;
			cury=gridy*RSIZE2+RSIZE1;

		//checking for existing room

		tmpvroom=head;

		while (tmpvroom!=0)
		{
			checkx=tmpvroom->x;
			checky=tmpvroom->y;

			if (checkx==curx && checky==cury && tmpvroom->rlevel==cur_level) 
			{
				set_curroom(tmpvroom);
				return FALSE;
			}
			tmpvroom=tmpvroom->next;
		}

		sprintf(buf,"%i",cntr);
		myroom=(struct _vroom*)new_vroom();
		new_room(myroom,buf,curx,cury);

		myroom->prev=0;
		myroom->next=head;
		head->prev=myroom;
		head=myroom;

		set_curroom(myroom);
		cntr++;
		}
		
	  return TRUE;
	}

	 


	int set_curroom(struct _vroom* cr)
	{

		if (!_curroom)
		{
			
		gnome_canvas_item_set(
		cr->text,"fill-color",ACTIVE_TEXT_COLOR,NULL);
		gnome_canvas_item_set(
		cr->rectangle,"outline-color",ACTIVE_RECT_COLOR,NULL);
		_curroom=cr;
		return;
		
		}

		if (_curroom->edited!=1) {
		gnome_canvas_item_set(_curroom->text,"fill-color",TEXT_COLOR,NULL);
		gnome_canvas_item_set(_curroom->rectangle,"outline-color",RECT_COLOR,NULL);
		} else {
		gnome_canvas_item_set(_curroom->text,"fill-color",TEXT_COLOR,NULL);
		gnome_canvas_item_set(_curroom->rectangle,"outline-color","brown",NULL);
		}
		_curroom=cr;

		if (_curroom->edited!=1) {
		gnome_canvas_item_set(_curroom->text,"fill-color",ACTIVE_TEXT_COLOR,NULL);
		gnome_canvas_item_set(_curroom->rectangle,"outline-color",ACTIVE_RECT_COLOR,NULL); } else 
	{

	gnome_canvas_item_set(_curroom->text,"fill-color",ACTIVE_TEXT_COLOR,NULL);
	gnome_canvas_item_set(_curroom->rectangle,"outline-color","orange",NULL); 

	}
}

int emulate_key_event(int nkey)
{
	GdkEventKey newkey;
	newkey.keyval=65456+nkey;
	on_canvas1_key_press_event(0,&newkey,0);
}

void on_button1_clicked (GtkButton *button, gpointer user_data)
{ emulate_key_event(7); }

void on_button2_clicked(GtkButton *button,gpointer user_data)
{ emulate_key_event(8); }

void on_button3_clicked(GtkButton *button, gpointer user_data)
{ emulate_key_event(9); }

void on_button4_clicked(GtkButton *button, gpointer user_data)
{ emulate_key_event(4); }

void on_button5_clicked(GtkButton *button, gpointer         user_data)
{ emulate_key_event(6); }

void on_button6_clicked(GtkButton       *button, gpointer         user_data)
{ emulate_key_event(1); }

void on_button7_clicked(GtkButton       *button, gpointer         user_data)
{ emulate_key_event(2); }

void on_button8_clicked(GtkButton       *button, gpointer         user_data)
{ emulate_key_event(3); }


void
on_new1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	struct _vroom *tmpr;
	tmpr=head;
	if (head==0) return;
	switch_to_current_level();
	while (head!=0) emulate_key_event(79);

	
	_curroom=0;
	memset(areaname,0x0,100);
	on_fit_to_screen1_activate(menuitem,user_data);
}


void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	whattodo=0;	
	fileselection=create_fileselection1();
	gtk_widget_show(fileselection);
}


void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if (head==0)
	{
		status_msg("Cannot save empty area");
		return;
	}
	if (strlen(areaname)==0) on_save_as1_activate(menuitem,user_data);
	else save_area(areaname);
}


void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

	if (head==0)
	{
		status_msg("Cannot save empty area");
		return;
	}
	whattodo=1;
	fileselection=create_fileselection1();
	gtk_widget_show(fileselection);
}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ gtk_main_quit(); }



void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *wac;
	wac=create_aboutger();
	gtk_widget_show(wac);
}


void
on_rooms_source1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

	PangoFontDescription *fontdesc;
	char fnn[200];
	char *home_dir;
	
	if (head==0)
	{
		status_msg("No rooms exist!");
		return;
	}
	home_dir=getenv("HOME");
	strcpy(fnn,home_dir);
	
	strcat(fnn,"/.mudsbuilder/");
	
	strcat(fnn,MUDLIB_TEMPLATE);
	
	generate_room(fnn,_curroom,0,0);
	
	free(home_dir);
/*
	fontdesc=pango_font_description_from_string(
		SOURCE_FONT);
	gtk_widget_modify_font(textview,fontdesc);
	pango_font_description_free(fontdesc);
*/	
	
}



void
on_zoom_in1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if (cur_level->_zoom<ZOOM_MAX) 
 	{ cur_level->_zoom+=ZOOM_STEP;
	gnome_canvas_set_pixels_per_unit((GnomeCanvas*)cur_level->canvas,cur_level->_zoom);
	}
}


void
on_zoom_out1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if (cur_level->_zoom>ZOOM_MIN)
	{
	 cur_level->_zoom-=ZOOM_STEP;
	gnome_canvas_set_pixels_per_unit((GnomeCanvas*)cur_level->canvas,
	cur_level->_zoom);
	}
}


void
on_fit_to_screen1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	cur_level->_zoom=1.0;
	gnome_canvas_set_pixels_per_unit((GnomeCanvas*)cur_level->canvas,cur_level->_zoom);
}


gboolean
on_vbox1_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                       gpointer         user_data)

{
	on_canvas1_key_press_event(widget,event,user_data);
}

void
on_button9_pressed                     (GtkButton       *button,
                                        gpointer         user_data)
{ emulate_key_event(79); }






//going up
void
on_button12_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	if (curx!=-1 && cury!=-1) 
	{
		switch_to_current_level();
		go_level(1);
	}
}


//going down
void
on_button13_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	if (curx!=-1 && cury!=-1) 
	{
		switch_to_current_level();
		go_level(-1);
	}
}


gboolean
on_window1_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  on_canvas1_key_press_event(widget,event,user_data);
  return TRUE;
}


void
on_randomize1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	int i;
	int randd;
	int start_cntr;

	srand(time(NULL));
	start_cntr=cntr+20;
	do
	{
		randd=rand()%8+1;
		if (randd!=5)
		emulate_key_event(randd);
	}
	while (cntr!=start_cntr);
}


void
on_generatebtn_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

	char ml[200];
	
	GtkWidget *e7,*e1,*e2,*e3,*e4,*e5,*e6;
	if (head==0) 
	{
		status_msg("In order to generate you must first create area");
		return;
	}

	gen_dialog=create_generate_dialog();
	e1=lookup_widget(gen_dialog,"entry3");
	e2=lookup_widget(gen_dialog,"entry4");
	e3=lookup_widget(gen_dialog,"entry5");
	e4=lookup_widget(gen_dialog,"entry6");
	e5=lookup_widget(gen_dialog,"entry7");
	e6=lookup_widget(gen_dialog,"entry8");
	e7=lookup_widget(gen_dialog,"entry2");
	
	
	gtk_entry_set_text((GtkEntry*)e1,ROOM_PREFIX);
	gtk_entry_set_text((GtkEntry*)e2,AREA_NAME);
	gtk_entry_set_text((GtkEntry*)e3,FILE_EXT);
	gtk_entry_set_text((GtkEntry*)e4,COMMENT);
	gtk_entry_set_text((GtkEntry*)e5,CREATOR_NAME);
	gtk_entry_set_text((GtkEntry*)e6,MUDLIB_TEMPLATE);

	char *hm;
	hm=getenv("HOME");
	
	strcpy(ml,hm);
	strcat(ml,"/.mudsbuilder/");
	strcat(ml,AREA_NAME);
	strcat(ml,"/");
	gtk_entry_set_text((GtkEntry*)e7,ml);
	gtk_widget_show(gen_dialog);
	free(hm);
}


void
on_button21_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *ww;
	GtkTextBuffer *gb;
	GtkTextIter start_iter;
	GtkTextIter end_iter;
	
	char *hm;
	char fnm[200];
	FILE *of;
	int sof;
	char *buf_m;
	
	if (strlen(areaname)==0)
	{
		ww=create_messagebox1();
		gtk_widget_show(ww);
	}
	else
	{
		_curroom->edited=1;
		gnome_canvas_item_set(
			_curroom->rectangle,
			"outline-color","brown",NULL);
	
		//saving room
		hm=getenv("HOME");
		strcpy(fnm,hm);
		strcat(fnm,"/.mudsbuilder/.tmpsaved_");
		strcat(fnm,(char*)basename(areaname));
		strcat(fnm,"_room");
		strcat(fnm,_curroom->id);
	
		of=fopen(fnm,"w");
		gb=gtk_text_view_get_buffer((GtkTextView*)lookup_widget(preview_dialog,"textview1"));
		sof=gtk_text_buffer_get_char_count(gb);
	
		gtk_text_buffer_get_start_iter(gb,&start_iter);
		gtk_text_buffer_get_end_iter(gb,&end_iter);
		buf_m=gtk_text_buffer_get_text(gb,&start_iter,&end_iter,TRUE);
		fwrite(buf_m,sizeof(char),strlen(buf_m),of);
		fclose(of);
		gtk_widget_destroy(preview_dialog);
		free(hm);
	}
}


void
on_notebook1_switch_page               (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        guint            page_num,
                                        gpointer         user_data)
{
	char clev[300];
	struct _level *cll;
	int lint;
	
	GtkWidget *llab;
	GtkWidget *child;

	//if (curx==-1 || cury==-1) return;
	child=gtk_notebook_get_nth_page(
	(GtkNotebook*)notebook,page_num);


	llab=gtk_notebook_get_tab_label(
		(GtkNotebook*)notebook,child);
	
	strcpy(clev,gtk_label_get_text((GtkLabel*)llab));
	
	lint=get_map_level(clev);
	
	
	if (cur_level->lev_id==lint) return;
	cll=cur_level;
	
	while (cll->prev!=0) cll=cll->prev;

	while (cll!=0)
	{
		if (lint==cll->lev_id)
		{
			cur_level=cll;
			return;
		}

		cll=cll->next;
	}

	
	
}


void
on_button11_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	char *cex[]={ "southwest","south","southeast","west",
		      "east", "northwest","north","northeast"};

	GtkWidget *combo1;
	GtkWidget *textview4;
	char rexx[1000];
	struct _vexitnode *t_e_n;
	GList *items=NULL;

	struct _vroom *tmp;
	int i;
	
	if (curx==-1 || cury==-1) return;

	memset(rexx,0x0,1000);
	
	dl3=create_dialog3();
	gtk_widget_show(dl3);
	
	textview4=lookup_widget(dl3,"textview4");
	combo1=lookup_widget(dl3,"combo1");

	for (i=0; i<8; i++)
	{
		if (_curroom->room_ptr[i]!=0)
		{
			strcat(rexx,cex[i]);
			strcat(rexx,"\t:\t");
			strcat(rexx,AREA_NAME);
			strcat(rexx,_curroom->room_ptr[i]->id);
			strcat(rexx,"\n");
		}
	}
	
	if (_curroom->up) {
		strcat(rexx,"up\t:\t");
		strcat(rexx,AREA_NAME);
		strcat(rexx,_curroom->up->id);
		strcat(rexx,"\n");
	}

	if (_curroom->down) {
		strcat(rexx,"down\t:\t");
		strcat(rexx,AREA_NAME);
		strcat(rexx,_curroom->down->id);
		strcat(rexx,"\n");
	}


	t_e_n=_curroom->head_exit;
	
	while (t_e_n!=0)
	{
		strcat(rexx,t_e_n->ex_name);
		strcat(rexx,"\t:\t");
		strcat(rexx,AREA_NAME);
		strcat(rexx,t_e_n->room_ptr->id);
		strcat(rexx,"\n");
		t_e_n=t_e_n->next;
		
	}
	
	GtkWidget *textb;
	textb=(GtkWidget*)gtk_text_buffer_new(NULL);
	gtk_text_buffer_set_text((GtkTextBuffer*)textb,rexx,strlen(rexx));
	gtk_text_view_set_buffer((GtkTextView*)textview4,(GtkTextBuffer*)textb);
	
	tmp=head;

	while (tmp!=0)
	{
		if (tmp->rlevel->lev_id==_curroom->rlevel->lev_id)
		{
			items=g_list_append(items,tmp->id);
		}
		tmp=tmp->next;
	}

	gtk_combo_set_popdown_strings((GtkCombo*)combo1,items);
}



//dialog2 - cancel
void
on_button25_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
}

//dialog2 -ok
void
on_button26_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
}

void
on_button27_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gtk_object_destroy((GtkObject*)dl3); }


void
on_button28_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	
	char c_entry1[100];
	char c_entry2[100];
	struct _vexitnode *new_vexit;
	struct _vroom *tmpr;
	GtkWidget *entry;
	GtkWidget *ex_name_entry;
	GtkWidget *combo1;
	GtkTextBuffer *mb;
	int i_entry;


	combo1=lookup_widget(dl3,"combo1");
	ex_name_entry=lookup_widget(dl3,"entry1");
	entry=((GtkCombo*)combo1)->entry;
	strcpy(c_entry1,gtk_entry_get_text((GtkEntry*)ex_name_entry));
	strcpy(c_entry2,gtk_entry_get_text((GtkEntry*)entry));
	i_entry=atoi(c_entry2);
	
	new_vexit=malloc(sizeof(struct _vexitnode));
	new_vexit->ex_name=malloc(sizeof(char)*strlen(c_entry1));
	strcpy(new_vexit->ex_name,c_entry1);
	
	tmpr=head;
	while (tmpr!=0)
	{
		if (strcmp(tmpr->id,c_entry2)==0) {
			new_vexit->room_ptr=tmpr;
		}
		tmpr=tmpr->next;
	}
	
	new_vexit->prev=0;
	new_vexit->next=_curroom->head_exit;
	if (_curroom->head_exit!=0) _curroom->head_exit->prev=new_vexit;

	_curroom->head_exit=new_vexit;
	
	GnomeCanvasPoints *pz;
	pz=gnome_canvas_points_new(2);
	pz->coords[0]=_curroom->x+RSIZE1;
	pz->coords[1]=_curroom->y+RSIZE1;
	pz->coords[2]=_curroom->head_exit->room_ptr->x+RSIZE1;
	pz->coords[3]=_curroom->head_exit->room_ptr->y+RSIZE1;
	
	_curroom->head_exit->line=gnome_canvas_item_new(
	cur_level->group,
	GNOME_TYPE_CANVAS_LINE,
	"points",pz,
	"fill_color",EXIT_COLOR,
	"last_arrowhead",TRUE,
	"arrow_shape_a",14.0,
	"arrow_shape_b",19.0,
	"arrow_shape_c",4.0,
	NULL);
	gnome_canvas_points_free(pz);
	
	
	gtk_object_destroy((GtkObject*)dl3);
}


void
on_button10_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	on_rooms_source1_activate((GtkMenuItem*)button,user_data);	
}




void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	char *name;
	name=(gchar*)
	gtk_file_selection_get_filename((GtkFileSelection*)fileselection);

	strcpy(areaname,name);

	if (whattodo==1) save_area(areaname);
	else  load_area(areaname);
	
gtk_object_destroy((GtkObject*)fileselection);
	
}


void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_object_destroy((GtkObject*)fileselection);
}


void
on_button22_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_object_destroy((GtkObject*)preview_dialog);
}






char *get_areaname() { return areaname; }

void
on_button29_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	_curroom->edited=0;
	char fnn[200];
	char *home_dir;
	
	gtk_object_destroy((GtkObject*)preview_dialog);
	if (head==0)
	{
		status_msg("No rooms exist!");
		return;
	}
	home_dir=getenv("HOME");
	strcpy(fnn,home_dir);
	
	strcat(fnn,"/.mudsbuilder/");
	
	strcat(fnn,MUDLIB_TEMPLATE);
	
	generate_room(fnn,_curroom,0,0);
	set_curroom(_curroom);
	free(home_dir);
}


void
on_about_btn_view_gpl_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
//	wgpl=create_window2();
//	gtk_widget_show(wgpl);
}

void
on_gnu_gpl_close_btn_clicked(GtkButton *button, gpointer user_data)
{ gtk_object_destroy((GtkObject*)wgpl); }



int set_globals(double a,double b, int c)
{
	curx=a; cury=b;
	
	isrx=(int)(a-RSIZE1)/(RSIZE2) % 2;
	isry=(int)(b-RSIZE1)/(RSIZE2) %2 ; 
	cntr=c;
}

int set_areaname(char *s)
{
	strcpy(areaname,s);
}

void
on_button31_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_object_destroy((GtkObject*)gen_dialog);
}


void
on_button32_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	char 
		*gen_dir, 
		*room_prefix,
		*area_name,
		*file_extension,
		*comment_symbol,
		*creators_name,
		*room_template;

		
		gen_dir=(char*)gtk_entry_get_text((GtkEntry*)lookup_widget(gen_dialog,"entry2"));
		room_prefix=(char*)gtk_entry_get_text((GtkEntry*)lookup_widget(gen_dialog,"entry3"));
		area_name=(char*)gtk_entry_get_text((GtkEntry*)lookup_widget(gen_dialog,"entry4"));
		file_extension=(char*)gtk_entry_get_text((GtkEntry*)lookup_widget(gen_dialog,"entry5"));
		comment_symbol=(char*)gtk_entry_get_text((GtkEntry*)lookup_widget(gen_dialog,"entry6"));
		creators_name=(char*)gtk_entry_get_text((GtkEntry*)lookup_widget(gen_dialog,"entry7"));
		room_template=(char*)gtk_entry_get_text((GtkEntry*)lookup_widget(gen_dialog,"entry8"));
		
		
		strcpy(ROOM_PREFIX,room_prefix);
		strcpy(AREA_NAME,area_name);
		strcpy(FILE_EXT,file_extension);
		strcpy(CREATOR_NAME,creators_name);
		strcpy(MUDLIB_TEMPLATE,room_template);

		g_print("\nCreating dir %s\n",gen_dir);
		mkdir(gen_dir,0777);
		
		generate_area(gen_dir);
	gtk_object_destroy((GtkObject*)gen_dialog);
}









void
on_entry4_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
	char *hm;
	char hmm[200];
	GtkWidget *e2, *ar_name;
	ar_name=lookup_widget(gen_dialog,"entry2");
	e2=lookup_widget(gen_dialog,"entry4");
	
	hm=getenv("HOME");
	strcpy(hmm,hm);
	strcat(hmm,"/.mudsbuilder/");
	strcat(hmm,(char*)gtk_entry_get_text((GtkEntry*)e2));
	strcat(hmm,"/");
	gtk_entry_set_text((GtkEntry*)ar_name,hmm);
	free(hm);
}


void
on_how_to1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GError *errr=NULL;
	gnome_help_display("README.html",NULL,&errr);
//	g_print(errr->message);
}

