#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <gnome.h>
#include "defines.h"
#include "draw.h"
#include "defines.h"
#include "generate.h"


void draw_grid(GnomeCanvasGroup *group,char *col)
{
	
	int i;
	gnome_canvas_item_new(
	group, GNOME_TYPE_CANVAS_RECT,
	"x1",(double)RSIZE1,
	"y1",(double)RSIZE1,
	"x2",(double)GSIZE*RSIZE2-RSIZE1,
	"y2",(double)GSIZE*RSIZE2-RSIZE1,
	"fill_color",CANVAS_COLOR,NULL);
	for (i=0; i<GSIZE; i++)
	{
		draw_a_line(group,
		i*RSIZE2+RSIZE1,
		RSIZE1,
		i*RSIZE2+RSIZE1,
		GSIZE*RSIZE2-RSIZE1,
		col);
		
		draw_a_line(group,
		RSIZE1,
		i*RSIZE2+RSIZE1,
		GSIZE*RSIZE2-RSIZE1,
		i*RSIZE2+RSIZE1,
		col);
	}
}

void draw_a_line(GnomeCanvasGroup *group, int x1,int y1,int x2,int y2, char *color)
{
	GnomeCanvasPoints *points;
	points=gnome_canvas_points_new(2);
	points->coords[0]=x1;
	points->coords[1]=y1;
	points->coords[2]=x2;
	points->coords[3]=y2;

	gnome_canvas_item_new(group,
		gnome_canvas_line_get_type(),
		"points",points,
		"fill_color",color,
		"width_units",1.0,
		NULL);

	gnome_canvas_points_free(points);		
}
